;;; ps7-compose.scm  compose-streams
(define (compose-series p1 p2)
  (define (get-first-nonzero-term s)
    (let ((term (first-term s)))
      (if (equ? (coefficient term) 0)
	  (get-first-nonzero-term (rest-terms s))
	  term)))
  (define (f t st)
    (scale-series (coefficient t) (series-power (order t) st)))
  (define (helper1 n)
    (define (loop1 k s result)
      (if (> k n)
	  result
	  (loop1
	   (+ k 1)
	   (rest-terms s)
	   (add-series
	    result
	    (f (first-term s) p2)))))
    (loop1 1 (rest-terms p1) (f (first-term p1) p2)))
  (define (helper2 i)
    (define (loop2 ser)
      (let ((term (first-term ser)))
        (if (= (order term) i)
	    term
	    (loop2 (rest-terms ser)))))
    (cons-stream (loop2 (helper1 i))
		 (helper2 (+ i 1))))
  (let ((term (get-first-nonzero-term p2)))
    (if (= (order term) 0)
	(error "COMPOSE-SERIES series P2 can't start with " term)
	(helper2 (* (order (first-term p1)) (order term))))))

(define (self-compose-series x) (compose-series x x))
